package org.gcube.portlets.user.dataminermanager.client.events;

import org.gcube.portlets.user.dataminermanager.shared.data.ComputationId;

import com.google.gwt.event.shared.EventHandler;
import com.google.gwt.event.shared.GwtEvent;
import com.google.gwt.event.shared.HandlerRegistration;
import com.google.gwt.event.shared.HasHandlers;

/**
 * Resubmit Computation Execution Request Event
 * 
 * 
 * @author "Giancarlo Panichi" <a
 *         href="mailto:g.panichi@isti.cnr.it">g.panichi@isti.cnr.it</a>
 *
 */
public class ResubmitComputationExecutionRequestEvent
		extends
		GwtEvent<ResubmitComputationExecutionRequestEvent.ResubmitComputationExecutionRequestEventHandler> {

	public static Type<ResubmitComputationExecutionRequestEventHandler> TYPE = new Type<ResubmitComputationExecutionRequestEventHandler>();
	private ComputationId computationId;

	public interface ResubmitComputationExecutionRequestEventHandler extends
			EventHandler {
		void onResubmit(ResubmitComputationExecutionRequestEvent event);
	}

	public interface HasResubmitComputationExecutionRequestEventHandler extends
			HasHandlers {
		public HandlerRegistration addResubmitComputationExecutionRequestEventHandler(
				ResubmitComputationExecutionRequestEventHandler handler);
	}

	public ResubmitComputationExecutionRequestEvent(ComputationId computationId) {
		this.computationId = computationId;
	}

	@Override
	protected void dispatch(ResubmitComputationExecutionRequestEventHandler handler) {
		handler.onResubmit(this);
	}

	@Override
	public Type<ResubmitComputationExecutionRequestEventHandler> getAssociatedType() {
		return TYPE;
	}

	public static Type<ResubmitComputationExecutionRequestEventHandler> getType() {
		return TYPE;
	}

	public static void fire(HasHandlers source,
			ResubmitComputationExecutionRequestEvent event) {
		source.fireEvent(event);
	}

	public ComputationId getComputationId() {
		return computationId;
	}

	@Override
	public String toString() {
		return "ResubmitComputationExecutionRequestEvent [computationId="
				+ computationId + "]";
	}

	
}
