package org.gcube.portlets.user.dataminermanager.server.smservice;

import java.util.List;

import org.gcube.portlets.user.dataminermanager.client.bean.ComputationItem;
import org.gcube.portlets.user.dataminermanager.client.bean.ComputationStatus;
import org.gcube.portlets.user.dataminermanager.client.bean.Operator;
import org.gcube.portlets.user.dataminermanager.client.bean.OperatorsClassification;
import org.gcube.portlets.user.dataminermanager.client.bean.output.Resource;
import org.gcube.portlets.user.dataminermanager.client.bean.parameters.Parameter;
import org.gcube.portlets.user.dataminermanager.shared.data.ComputationId;

/**
 * 
 * Client
 * 
 * @author giancarlo email: <a
 *         href="mailto:g.panichi@isti.cnr.it">g.panichi@isti.cnr.it</a>
 *
 */
public abstract class SClient {

	public SClient() {
		super();
	}

	public abstract List<OperatorsClassification> getOperatorsClassifications()
			throws Exception;

	public abstract List<Parameter> getInputParameters(Operator operator)
			throws Exception;

	public abstract ComputationId startComputation(Operator operator,
			String computationTitle, String computationDescription)
			throws Exception;

	public abstract ComputationStatus getComputationStatus(
			ComputationId computationId) throws Exception;

	public abstract Resource getResourceByComputationId(
			ComputationId computationId) throws Exception;

	public abstract String cancelComputation(ComputationId computationId)
			throws Exception;

	public abstract ComputationId resubmitComputation(
			ComputationId computationId) throws Exception;
	
	@Override
	public String toString() {
		return "SClient []";
	}
}